----------------------------------------------------------------------------
-- @Author: ViperGTS96----------------------------------------------
----------------------------------------------------------------------------
--------------------"The simplest design is the best design." --------
----------------------------------------------------------------------------
----------------------------------------------------------------------------
GameSaver = {};
GameSaver.render = false;
GameSaver.showSaveDialog = false;

function GameSaver:update(superfunc, dt)
	if self:getIsAutoSaveAllowed() and g_currentMission:getIsServer() and g_currentMission.gameStarted and self.time < g_time then
		self.isPending = true;
		self:runAutoSaveIfPending(true);
		self.saveNextFrame = false;
		GameSaver.render = true;
	end;
	GameSaver:completedSaveDisplay();
end;
AutoSaveManager.update = Utils.overwrittenFunction(AutoSaveManager.update, GameSaver.update);

function GameSaver:startSavingGameDisplay(superfunc)
	if g_gui:getIsGuiVisible() or GameSaver.showSaveDialog then
		g_gui:showMessageDialog({isCloseAllowed = false, visible = true, text = g_i18n:getText("ui_savingContent")}); -- self.l10n:getText(InGameMenu.L10N_SYMBOL.SAVING_CONTENT)
		self.savingMinEndTime = getTimeSec() + SavegameController.SAVING_DURATION;
		self.isSaving = true;
		self.isSavingWithGUI = true;
	end;
end;
InGameMenu.startSavingGameDisplay = Utils.overwrittenFunction(InGameMenu.update, GameSaver.startSavingGameDisplay);

function GameSaver:completedSaveDisplay()
	if GameSaver.render then
		local sec = g_time/1000;
		if GameSaver.renderTimeInt == nil then
			GameSaver.renderTimeInt = sec;
		end;
		local delayTime = (2+SavegameController.SAVING_DURATION) - (sec - GameSaver.renderTimeInt);
		if delayTime < 0 then
			GameSaver.render = false;
			GameSaver.renderTimeInt = nil;
			----
			g_currentMission.inGameMenu.doSaveGameState = InGameMenu.SAVE_STATE_NONE;
			g_currentMission.inGameMenu.savingMinEndTime = 0;
			g_currentMission.inGameMenu.isSaving = false;
			g_currentMission.inGameMenu.savingDisplayTimer = nil;
			----
			if g_currentMission.inGameMenu.isSavingWithGUI ~= nil then
				g_gui:showMessageDialog({visible = false});
				g_currentMission.inGameMenu.isSavingWithGUI = nil;
			end;
			----
			local text = g_i18n:getText("ui_autoSave").." "..string.lower(g_i18n:getText("fieldJob_finished")); -- > "Auto save completed"
			g_currentMission.hud:addSideNotification({0,1,0,1}, text, nil, GuiSoundPlayer.SOUND_SAMPLES.NOTIFICATION);
		end;
	end;
end;